""" Version: 1.0.0.0
This module represents the scripting PythonAPI available in RazorEnhanced.
This class is NOT intended to be used as code, but to provice autocomplete in external editors and generation documentation.
"""
from typing import *
class String(str): pass
class Object: pass
class Boolean: pass
class Byte(int): pass
class Int(int): pass 
class Int32(int): pass 
class UInt32(int): pass
class Float(float): pass
class Single(float): pass
class Double(float): pass

class Filter:
	"""		
	"""
	Blessed: int
	Bodies: "List[Int32]"
	CheckIgnoreObject: bool
	CheckIgnoreObject: bool
	CheckLineOfSight: bool
	CheckLineOfSite: bool
	Enabled: bool
	Enabled: bool
	Female: int
	Friend: int
	Graphics: "List[Int32]"
	Graphics: "List[Int32]"
	Hues: "List[Int32]"
	Hues: "List[Int32]"
	IgnorePets: bool
	IsContainer: int
	IsCorpse: int
	IsDoor: int
	IsGhost: int
	IsHuman: int
	Layers: "List[String]"
	Movable: int
	Multi: int
	Name: str
	Name: str
	Notorieties: "List[Byte]"
	OnGround: int
	Paralized: int
	Poisoned: int
	RangeMax: float
	RangeMax: float
	RangeMin: float
	RangeMin: float
	Serials: "List[Int32]"
	Serials: "List[Int32]"
	Warmode: int
	ZLevelMax: float
	ZLevelMin: float
	ZRangeMax: float
	ZRangeMin: float
	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""


class Filter:
	"""		
	"""
	Blessed: int
	Bodies: "List[Int32]"
	CheckIgnoreObject: bool
	CheckIgnoreObject: bool
	CheckLineOfSight: bool
	CheckLineOfSite: bool
	Enabled: bool
	Enabled: bool
	Female: int
	Friend: int
	Graphics: "List[Int32]"
	Graphics: "List[Int32]"
	Hues: "List[Int32]"
	Hues: "List[Int32]"
	IgnorePets: bool
	IsContainer: int
	IsCorpse: int
	IsDoor: int
	IsGhost: int
	IsHuman: int
	Layers: "List[String]"
	Movable: int
	Multi: int
	Name: str
	Name: str
	Notorieties: "List[Byte]"
	OnGround: int
	Paralized: int
	Poisoned: int
	RangeMax: float
	RangeMax: float
	RangeMin: float
	RangeMin: float
	Serials: "List[Int32]"
	Serials: "List[Int32]"
	Warmode: int
	ZLevelMax: float
	ZLevelMin: float
	ZRangeMax: float
	ZRangeMin: float
	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""


class GumpData:
	"""		
	"""
	buttonid: int
	gumpData: "List[String]"
	gumpDefinition: str
	gumpId: "UInt32"
	gumpLayout: str
	gumpStrings: "List[String]"
	gumpText: "List[String]"
	hasResponse: bool
	layoutPieces: "List[String]"
	serial: "UInt32"
	stringList: "List[String]"
	switches: "List[Int32]"
	text: "List[String]"
	textID: "List[Int32]"
	x: "UInt32"
	y: "UInt32"
	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""


class Gumps:
	"""		
	"""

	@staticmethod
	def AddAlphaRegion(gd: "GumpData&@", x: int, y: int, width: int, height: int):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		width: int
		height: int
		
		"""

	@staticmethod
	def AddBackground(gd: "GumpData&@", x: int, y: int, width: int, height: int, gumpId: int):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		width: int
		height: int
		gumpId: int
		
		"""

	@staticmethod
	def AddButton(gd: "GumpData&@", x: int, y: int, normalID: int, pressedID: int, buttonID: int, type: int, param: int):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		normalID: int
		pressedID: int
		buttonID: int
		type: int
		param: int
		
		"""

	@staticmethod
	def AddCheck(gd: "GumpData&@", x: int, y: int, inactiveID: int, activeID: int, initialState: bool, switchID: int):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		inactiveID: int
		activeID: int
		initialState: bool
		switchID: int
		
		"""

	@staticmethod
	def AddGroup(gd: "GumpData&@", group: int):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		group: int
		
		"""

	@staticmethod
	def AddHtml(gd: "GumpData&@", x: int, y: int, width: int, height: int, text: Union[str, int], background: bool, scrollbar: bool):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		width: int
		height: int
		text: str or int
		background: bool
		scrollbar: bool
		
		"""

	@staticmethod
	def AddHtmlLocalized(gd: "GumpData&@", x: int, y: int, width: int, height: int, number: int, args: Union[str, int, bool], color: Union[int, bool], background: Union[bool, None] = None, scrollbar: Union[bool, None] = None):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		width: int
		height: int
		number: int
		args: str or int or bool
		color: int or bool
		background: bool or None
		scrollbar: bool or None
		
		"""

	@staticmethod
	def AddImage(gd: "GumpData&@", x: int, y: int, gumpId: int, hue: Union[int, None] = None):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		gumpId: int
		hue: int or None
		
		"""

	@staticmethod
	def AddImageTiled(gd: "GumpData&@", x: int, y: int, width: int, height: int, gumpId: int):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		width: int
		height: int
		gumpId: int
		
		"""

	@staticmethod
	def AddImageTiledButton(gd: "GumpData&@", x: int, y: int, normalID: int, pressedID: int, buttonID: int, type: "GumpButtonType", param: int, itemID: int, hue: int, width: int, height: int, localizedTooltip: Union[int, None] = None):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		normalID: int
		pressedID: int
		buttonID: int
		type: GumpButtonType
		param: int
		itemID: int
		hue: int
		width: int
		height: int
		localizedTooltip: int or None
		
		"""

	@staticmethod
	def AddItem(gd: "GumpData&@", x: int, y: int, itemID: int, hue: Union[int, None] = None):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		itemID: int
		hue: int or None
		
		"""

	@staticmethod
	def AddLabel(gd: "GumpData&@", x: int, y: int, hue: int, textID: Union[int, str]):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		hue: int
		textID: int or str
		
		"""

	@staticmethod
	def AddLabelCropped(gd: "GumpData&@", x: int, y: int, width: int, height: int, hue: int, text: Union[str, int]):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		width: int
		height: int
		hue: int
		text: str or int
		
		"""

	@staticmethod
	def AddPage(gd: "GumpData&@", page: int):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		page: int
		
		"""

	@staticmethod
	def AddRadio(gd: "GumpData&@", x: int, y: int, inactiveID: int, activeID: int, initialState: bool, switchID: int):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		inactiveID: int
		activeID: int
		initialState: bool
		switchID: int
		
		"""

	@staticmethod
	def AddSpriteImage(gd: "GumpData&@", x: int, y: int, gumpId: int, spriteX: int, spriteY: int, spriteW: int, spriteH: int):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		gumpId: int
		spriteX: int
		spriteY: int
		spriteW: int
		spriteH: int
		
		"""

	@staticmethod
	def AddTextEntry(gd: "GumpData&@", x: int, y: int, width: int, height: int, hue: int, entryID: int, initialText: Union[str, int]):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		x: int
		y: int
		width: int
		height: int
		hue: int
		entryID: int
		initialText: str or int
		
		"""

	@staticmethod
	def AddTooltip(gd: "GumpData&@", cliloc: Union[int, str], text: Union[str, None] = None):
		"""
		
		Parameters
		----------
		gd: GumpData&@
		cliloc: int or str
		text: str or None
		
		"""

	@staticmethod
	def AllGumpIDs() -> "List[UInt32]":
		"""
		
		Returns
		-------
		List[UInt32]
		
		"""

	@staticmethod
	def CloseGump(gumpid: "UInt32"):
		"""
		
		Parameters
		----------
		gumpid: UInt32
		
		"""

	@staticmethod
	def CreateGump(movable: bool, closable: bool, disposable: bool, resizeable: bool) -> "GumpData":
		"""
		
		Parameters
		----------
		movable: bool
		closable: bool
		disposable: bool
		resizeable: bool
		
		Returns
		-------
		GumpData
		
		"""

	@staticmethod
	def CurrentGump() -> "UInt32":
		"""
		
		Returns
		-------
		UInt32
		
		"""

	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def GetGumpData(gumpid: "UInt32") -> "GumpData":
		"""
		
		Parameters
		----------
		gumpid: UInt32
		
		Returns
		-------
		GumpData
		
		"""

	@staticmethod
	def GetGumpRawData(gumpid: "UInt32") -> str:
		"""
		
		Parameters
		----------
		gumpid: UInt32
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def GetGumpRawLayout(gumpid: "UInt32") -> str:
		"""
		
		Parameters
		----------
		gumpid: UInt32
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def GetGumpRawText(gumpid: "UInt32") -> "List[String]":
		"""
		
		Parameters
		----------
		gumpid: UInt32
		
		Returns
		-------
		List[String]
		
		"""

	@staticmethod
	def GetGumpText(gumpid: "UInt32") -> "List[String]":
		"""
		
		Parameters
		----------
		gumpid: UInt32
		
		Returns
		-------
		List[String]
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def GetLine(gumpId: "UInt32", line_num: int) -> str:
		"""
		
		Parameters
		----------
		gumpId: UInt32
		line_num: int
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def GetLineList(gumpId: "UInt32", dataOnly: bool) -> "List[String]":
		"""
		
		Parameters
		----------
		gumpId: UInt32
		dataOnly: bool
		
		Returns
		-------
		List[String]
		
		"""

	@staticmethod
	def GetResolvedStringPieces(gumpid: "UInt32") -> "List[String]":
		"""
		
		Parameters
		----------
		gumpid: UInt32
		
		Returns
		-------
		List[String]
		
		"""

	@staticmethod
	def GetTextByID(gd: "GumpData", id: int) -> str:
		"""
		
		Parameters
		----------
		gd: GumpData
		id: int
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def HasGump(gumpId: Union["UInt32", None] = None) -> bool:
		"""
		
		Parameters
		----------
		gumpId: UInt32 or None
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def IsValid(gumpId: int) -> bool:
		"""
		
		Parameters
		----------
		gumpId: int
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def LastGumpGetLine(line_num: int) -> str:
		"""
		
		Parameters
		----------
		line_num: int
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def LastGumpGetLineList() -> "List[String]":
		"""
		
		Returns
		-------
		List[String]
		
		"""

	@staticmethod
	def LastGumpRawLayout() -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def LastGumpTextExist(text: str) -> bool:
		"""
		
		Parameters
		----------
		text: str
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def LastGumpTextExistByLine(line_num: int, text: str) -> bool:
		"""
		
		Parameters
		----------
		line_num: int
		text: str
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def LastGumpTile() -> "List[Int32]":
		"""
		
		Returns
		-------
		List[Int32]
		
		"""

	@staticmethod
	def ResetGump():
		"""
		
		"""

	@staticmethod
	def SendAction(gumpid: "UInt32", buttonid: int):
		"""
		
		Parameters
		----------
		gumpid: UInt32
		buttonid: int
		
		"""

	@staticmethod
	def SendAdvancedAction(gumpid: "UInt32", buttonid: int, inSwitches: Union["List[Int32]", "PythonList"], textlist_id: Union["List[Int32]", "PythonList", "List[String]", None] = None, textlist_str: Union["List[String]", "PythonList", None] = None):
		"""
		
		Parameters
		----------
		gumpid: UInt32
		buttonid: int
		inSwitches: List[Int32] or PythonList
		textlist_id: List[Int32] or PythonList or List[String] or None
		textlist_str: List[String] or PythonList or None
		
		"""

	@staticmethod
	def SendGump(gumpid: Union["UInt32", "GumpData"], serial: "UInt32", x: "UInt32", y: Union["UInt32", None] = None, gumpDefinition: Union[str, None] = None, gumpStrings: Union["List[String]", None] = None):
		"""
		
		Parameters
		----------
		gumpid: UInt32 or GumpData
		serial: UInt32
		x: UInt32
		y: UInt32 or None
		gumpDefinition: str or None
		gumpStrings: List[String] or None
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def WaitForGump(gumpid: Union["UInt32", "PythonList"], delay: int) -> bool:
		"""
		
		Parameters
		----------
		gumpid: UInt32 or PythonList
		delay: int
		
		Returns
		-------
		bool
		
		"""


class Item:
	"""		
	"""
	Amount: int
	BuyDesc: str
	Color: "UInt16"
	Container: int
	ContainerOpened: bool
	Contains: "List[Item]"
	CorpseNumberItems: int
	Direction: str
	Durability: int
	Graphics: "UInt16"
	GridNum: int
	Hue: "UInt16"
	Image: "Bitmap"
	IsBagOfSending: bool
	IsContainer: bool
	IsCorpse: bool
	IsDoor: bool
	IsInBank: bool
	IsLootable: bool
	IsPotion: bool
	IsResource: bool
	IsSearchable: bool
	IsTwoHanded: bool
	IsVirtueShield: bool
	ItemID: int
	Layer: str
	Light: int
	MaxDurability: int
	Movable: bool
	Name: str
	OnGround: bool
	Price: int
	Properties: "List[Property]"
	PropsUpdated: bool
	RootContainer: int
	Serial: int
	TypeID: "UInt16"
	Updated: bool
	Visible: bool
	Weight: int
	def DistanceTo(self, itm: Union["Item", "Mobile"]) -> int:
		"""
		
		Parameters
		----------
		itm: Item or Mobile
		
		Returns
		-------
		int
		
		"""

	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def GetWorldPosition(self) -> "Point3D":
		"""
		
		Returns
		-------
		Point3D
		
		"""

	def IsChildOf(self, container: Union["Item", "Mobile"], maxDepth: int) -> bool:
		"""
		
		Parameters
		----------
		container: Item or Mobile
		maxDepth: int
		
		Returns
		-------
		bool
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""


class Items:
	"""		
	"""

	@staticmethod
	def ApplyFilter(filter: "Filter") -> "List[Item]":
		"""
		
		Parameters
		----------
		filter: Filter
		
		Returns
		-------
		List[Item]
		
		"""

	@staticmethod
	def BackpackCount(itemid: int, color: int) -> int:
		"""
		
		Parameters
		----------
		itemid: int
		color: int
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def ChangeDyeingTubColor(dyes: "Item", dyeingTub: "Item", color: int):
		"""
		
		Parameters
		----------
		dyes: Item
		dyeingTub: Item
		color: int
		
		"""

	@staticmethod
	def Close(item: Union["Item", int]):
		"""
		
		Parameters
		----------
		item: Item or int
		
		"""

	@staticmethod
	def Color(serial: int, color: int):
		"""
		
		Parameters
		----------
		serial: int
		color: int
		
		"""

	@staticmethod
	def ContainerCount(serial: Union[int, "Item"], itemid: int, color: int, recursive: bool) -> int:
		"""
		
		Parameters
		----------
		serial: int or Item
		itemid: int
		color: int
		recursive: bool
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def ContextExist(i: Union["Item", int], name: str) -> int:
		"""
		
		Parameters
		----------
		i: Item or int
		name: str
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def DropFromHand(item: "Item", container: "Item"):
		"""
		
		Parameters
		----------
		item: Item
		container: Item
		
		"""

	@staticmethod
	def DropItemGroundSelf(serialitem: Union[int, "Item"], amount: int):
		"""
		
		Parameters
		----------
		serialitem: int or Item
		amount: int
		
		"""

	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def FindAllByID(itemids: Union["PythonList", int, "List[Int32]"], color: int, container: int, range: int, considerIgnoreList: bool) -> Union["List[Item]", "PythonList"]:
		"""
		
		Parameters
		----------
		itemids: PythonList or int or List[Int32]
		color: int
		container: int
		range: int
		considerIgnoreList: bool
		
		Returns
		-------
		List[Item], PythonList
		
		"""

	@staticmethod
	def FindByID(itemids: Union["List[Int32]", int], color: int, container: int, range: Union[int, bool], considerIgnoreList: bool) -> "Item":
		"""
		
		Parameters
		----------
		itemids: List[Int32] or int
		color: int
		container: int
		range: int or bool
		considerIgnoreList: bool
		
		Returns
		-------
		Item
		
		"""

	@staticmethod
	def FindByName(itemName: str, color: int, container: int, range: int, considerIgnoreList: bool) -> "Item":
		"""
		
		Parameters
		----------
		itemName: str
		color: int
		container: int
		range: int
		considerIgnoreList: bool
		
		Returns
		-------
		Item
		
		"""

	@staticmethod
	def FindBySerial(serial: int) -> "Item":
		"""
		
		Parameters
		----------
		serial: int
		
		Returns
		-------
		Item
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def GetImage(itemID: int, hue: int) -> "Bitmap":
		"""
		
		Parameters
		----------
		itemID: int
		hue: int
		
		Returns
		-------
		Bitmap
		
		"""

	@staticmethod
	def GetProperties(itemserial: int, delay: int) -> "List[Property]":
		"""
		
		Parameters
		----------
		itemserial: int
		delay: int
		
		Returns
		-------
		List[Property]
		
		"""

	@staticmethod
	def GetPropStringByIndex(serial: int, index: int) -> str:
		"""
		
		Parameters
		----------
		serial: int
		index: int
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def GetPropStringList(item: Union["Item", int]) -> "List[String]":
		"""
		
		Parameters
		----------
		item: Item or int
		
		Returns
		-------
		List[String]
		
		"""

	@staticmethod
	def GetPropValue(item: Union["Item", "Serial"], name: str) -> float:
		"""
		
		Parameters
		----------
		item: Item or Serial
		name: str
		
		Returns
		-------
		float
		
		"""

	@staticmethod
	def GetPropValueString(serial: int, name: str) -> str:
		"""
		
		Parameters
		----------
		serial: int
		name: str
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def GetWeaponAbility(itemId: int) -> "ValueTuple[String, String]":
		"""
		
		Parameters
		----------
		itemId: int
		
		Returns
		-------
		ValueTuple[String, String]
		
		"""

	@staticmethod
	def Hide(item: Union["Item", int]):
		"""
		
		Parameters
		----------
		item: Item or int
		
		"""

	@staticmethod
	def IgnoreTypes(itemIdList: "PythonList"):
		"""
		
		Parameters
		----------
		itemIdList: PythonList
		
		"""

	@staticmethod
	def Lift(item: "Item", amount: int):
		"""
		
		Parameters
		----------
		item: Item
		amount: int
		
		"""

	@staticmethod
	def Message(serial: Union[int, "Item"], hue: int, message: str):
		"""
		
		Parameters
		----------
		serial: int or Item
		hue: int
		message: str
		
		"""

	@staticmethod
	def Move(source: Union["Item", int], destination: Union["Mobile", int, "Item"], amount: int, x: Union[int, None] = None, y: Union[int, None] = None):
		"""
		
		Parameters
		----------
		source: Item or int
		destination: Mobile or int or Item
		amount: int
		x: int or None
		y: int or None
		
		"""

	@staticmethod
	def MoveOnGround(source: Union["Item", int], amount: int, x: int, y: int, z: int):
		"""
		
		Parameters
		----------
		source: Item or int
		amount: int
		x: int
		y: int
		z: int
		
		"""

	@staticmethod
	def Select(items: "List[Item]", selector: str) -> "Item":
		"""
		
		Parameters
		----------
		items: List[Item]
		selector: str
		
		Returns
		-------
		Item
		
		"""

	@staticmethod
	def SetColor(serial: int, color: int):
		"""
		
		Parameters
		----------
		serial: int
		color: int
		
		"""

	@staticmethod
	def SingleClick(itemserial: Union[int, "Item"]):
		"""
		
		Parameters
		----------
		itemserial: int or Item
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def UseItem(itemSerial: Union[int, "Item"], targetSerial: Union[int, None] = None, wait: Union[bool, None] = None):
		"""
		
		Parameters
		----------
		itemSerial: int or Item
		targetSerial: int or None
		wait: bool or None
		
		"""

	@staticmethod
	def UseItemByID(itemid: int, color: int) -> bool:
		"""
		
		Parameters
		----------
		itemid: int
		color: int
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def WaitForContents(bag_serial: Union[int, "Item"], delay: int) -> bool:
		"""
		
		Parameters
		----------
		bag_serial: int or Item
		delay: int
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def WaitForProps(itemserial: Union[int, "Item"], delay: int):
		"""
		
		Parameters
		----------
		itemserial: int or Item
		delay: int
		
		"""


class Journal:
	"""		
	"""

	def Clear(self, toBeRemoved: Union[str, None] = None):
		"""
		
		Parameters
		----------
		toBeRemoved: str or None
		
		"""

	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	def FilterText(self, text: str):
		"""
		
		Parameters
		----------
		text: str
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def GetJournalEntry(self, afterTimestap: Union[float, "JournalEntry"]) -> "List[JournalEntry]":
		"""
		
		Parameters
		----------
		afterTimestap: float or JournalEntry
		
		Returns
		-------
		List[JournalEntry]
		
		"""

	def GetLineText(self, text: str, addname: bool) -> str:
		"""
		
		Parameters
		----------
		text: str
		addname: bool
		
		Returns
		-------
		str
		
		"""

	def GetSpeechName(self) -> "List[String]":
		"""
		
		Returns
		-------
		List[String]
		
		"""

	def GetTextByColor(self, color: int, addname: bool) -> "List[String]":
		"""
		
		Parameters
		----------
		color: int
		addname: bool
		
		Returns
		-------
		List[String]
		
		"""

	def GetTextByName(self, name: str, addname: bool) -> "List[String]":
		"""
		
		Parameters
		----------
		name: str
		addname: bool
		
		Returns
		-------
		List[String]
		
		"""

	def GetTextBySerial(self, serial: int, addname: bool) -> "List[String]":
		"""
		
		Parameters
		----------
		serial: int
		addname: bool
		
		Returns
		-------
		List[String]
		
		"""

	def GetTextByType(self, type: str, addname: bool) -> "List[String]":
		"""
		
		Parameters
		----------
		type: str
		addname: bool
		
		Returns
		-------
		List[String]
		
		"""

	def RemoveFilterText(self, text: str):
		"""
		
		Parameters
		----------
		text: str
		
		"""

	def Search(self, text: str) -> bool:
		"""
		
		Parameters
		----------
		text: str
		
		Returns
		-------
		bool
		
		"""

	def SearchByColor(self, text: str, color: int) -> bool:
		"""
		
		Parameters
		----------
		text: str
		color: int
		
		Returns
		-------
		bool
		
		"""

	def SearchByName(self, text: str, name: str) -> bool:
		"""
		
		Parameters
		----------
		text: str
		name: str
		
		Returns
		-------
		bool
		
		"""

	def SearchByType(self, text: str, type: str) -> bool:
		"""
		
		Parameters
		----------
		text: str
		type: str
		
		Returns
		-------
		bool
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	def WaitByName(self, name: str, delay: int) -> bool:
		"""
		
		Parameters
		----------
		name: str
		delay: int
		
		Returns
		-------
		bool
		
		"""

	def WaitJournal(self, text: Union[str, "List[String]"], delay: int) -> Union[bool, str]:
		"""
		
		Parameters
		----------
		text: str or List[String]
		delay: int
		
		Returns
		-------
		bool, str
		
		"""


class JournalEntry:
	"""		
	"""
	Color: int
	Name: str
	Serial: int
	Text: str
	Timestamp: float
	Type: str
	def Copy(self) -> "JournalEntry":
		"""
		
		Returns
		-------
		JournalEntry
		
		"""

	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""


class Misc:
	"""		
	"""
	SharedScriptData: "Dictionary[String, Object]"
	@staticmethod
	def AllSharedValue() -> "List[String]":
		"""
		
		Returns
		-------
		List[String]
		
		"""

	@staticmethod
	def Beep():
		"""
		
		"""

	@staticmethod
	def CancelPrompt():
		"""
		
		"""

	@staticmethod
	def CheckIgnoreObject(serial: Union[int, "Entity"]) -> bool:
		"""
		
		Parameters
		----------
		serial: int or Entity
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def CheckSharedValue(name: str) -> bool:
		"""
		
		Parameters
		----------
		name: str
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def ClearIgnore():
		"""
		
		"""

	@staticmethod
	def CloseMenu():
		"""
		
		"""

	@staticmethod
	def ConfigDirectory() -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def ContextReply(entity: Union["Entity", int], menu_name: Union[str, int]):
		"""
		
		Parameters
		----------
		entity: Entity or int
		menu_name: str or int
		
		"""

	@staticmethod
	def CurrentScriptDirectory() -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def DataDirectory() -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def Disconnect():
		"""
		
		"""

	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def ExportPythonAPI(path: str, pretty: bool):
		"""
		
		Parameters
		----------
		path: str
		pretty: bool
		
		"""

	@staticmethod
	def FilterSeason(enable: bool, seasonFlag: "UInt32"):
		"""
		
		Parameters
		----------
		enable: bool
		seasonFlag: UInt32
		
		"""

	@staticmethod
	def FocusUOWindow():
		"""
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def GetMapInfo(serial: "UInt32") -> "MapInfo":
		"""
		
		Parameters
		----------
		serial: UInt32
		
		Returns
		-------
		MapInfo
		
		"""

	@staticmethod
	def GetMenuTitle() -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def HasMenu() -> bool:
		"""
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def HasPrompt() -> bool:
		"""
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def HasQueryString() -> bool:
		"""
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def IgnoreObject(entity: Union["Entity", int]):
		"""
		
		Parameters
		----------
		entity: Entity or int
		
		"""

	@staticmethod
	def LeftMouseClick(xpos: int, ypos: int, clientCoords: bool):
		"""
		
		Parameters
		----------
		xpos: int
		ypos: int
		clientCoords: bool
		
		"""

	@staticmethod
	def MenuContain(text: str) -> bool:
		"""
		
		Parameters
		----------
		text: str
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def MenuResponse(text: str):
		"""
		
		Parameters
		----------
		text: str
		
		"""

	@staticmethod
	def NoOperation():
		"""
		
		"""

	@staticmethod
	def NoRunStealthStatus() -> bool:
		"""
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def NoRunStealthToggle(enable: bool):
		"""
		
		Parameters
		----------
		enable: bool
		
		"""

	@staticmethod
	def Pause(millisec: int):
		"""
		
		Parameters
		----------
		millisec: int
		
		"""

	@staticmethod
	def PetRename(mob: Union["Mobile", int], name: str):
		"""
		
		Parameters
		----------
		mob: Mobile or int
		name: str
		
		"""

	@staticmethod
	def PlaySound(sound: int, x: int, y: int, z: int):
		"""
		
		Parameters
		----------
		sound: int
		x: int
		y: int
		z: int
		
		"""

	@staticmethod
	def QueryStringResponse(okcancel: bool, response: str):
		"""
		
		Parameters
		----------
		okcancel: bool
		response: str
		
		"""

	@staticmethod
	def RazorDirectory() -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def ReadSharedValue(name: str) -> object:
		"""
		
		Parameters
		----------
		name: str
		
		Returns
		-------
		object
		
		"""

	@staticmethod
	def RemoveSharedValue(name: str):
		"""
		
		Parameters
		----------
		name: str
		
		"""

	@staticmethod
	def ResetPrompt():
		"""
		
		"""

	@staticmethod
	def ResponsePrompt(text: str):
		"""
		
		Parameters
		----------
		text: str
		
		"""

	@staticmethod
	def Resync():
		"""
		
		"""

	@staticmethod
	def RightMouseClick(xpos: int, ypos: int, clientCoords: bool):
		"""
		
		Parameters
		----------
		xpos: int
		ypos: int
		clientCoords: bool
		
		"""

	@staticmethod
	def ScriptCurrent(fullpath: bool) -> str:
		"""
		
		Parameters
		----------
		fullpath: bool
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def ScriptDirectory() -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def ScriptIsSuspended(scriptfile: str) -> bool:
		"""
		
		Parameters
		----------
		scriptfile: str
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def ScriptResume(scriptfile: str):
		"""
		
		Parameters
		----------
		scriptfile: str
		
		"""

	@staticmethod
	def ScriptRun(scriptfile: str):
		"""
		
		Parameters
		----------
		scriptfile: str
		
		"""

	@staticmethod
	def ScriptStatus(scriptfile: str) -> bool:
		"""
		
		Parameters
		----------
		scriptfile: str
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def ScriptStop(scriptfile: str):
		"""
		
		Parameters
		----------
		scriptfile: str
		
		"""

	@staticmethod
	def ScriptStopAll(skipCurrent: bool):
		"""
		
		Parameters
		----------
		skipCurrent: bool
		
		"""

	@staticmethod
	def ScriptSuspend(scriptfile: str):
		"""
		
		Parameters
		----------
		scriptfile: str
		
		"""

	@staticmethod
	def SendMessage(msg: Union[str, int, "UInt32", bool, float, object, float], color: Union[int, bool, None] = None, wait: Union[bool, None] = None):
		"""
		
		Parameters
		----------
		msg: str or int or UInt32 or bool or float or object or float
		color: int or bool or None
		wait: bool or None
		
		"""

	@staticmethod
	def SetSharedValue(name: str, value: object):
		"""
		
		Parameters
		----------
		name: str
		value: object
		
		"""

	@staticmethod
	def ShardName() -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def UnIgnoreObject(entity: Union["Entity", int]):
		"""
		
		Parameters
		----------
		entity: Entity or int
		
		"""

	@staticmethod
	def UseContextMenu(serial: int, choice: str, delay: int) -> bool:
		"""
		
		Parameters
		----------
		serial: int
		choice: str
		delay: int
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def WaitForContext(serial: Union[int, "Mobile", "Item"], delay: int, showContext: bool) -> "List[Context]":
		"""
		
		Parameters
		----------
		serial: int or Mobile or Item
		delay: int
		showContext: bool
		
		Returns
		-------
		List[Context]
		
		"""

	@staticmethod
	def WaitForMenu(delay: int) -> bool:
		"""
		
		Parameters
		----------
		delay: int
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def WaitForPrompt(delay: int) -> bool:
		"""
		
		Parameters
		----------
		delay: int
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def WaitForQueryString(delay: int) -> bool:
		"""
		
		Parameters
		----------
		delay: int
		
		Returns
		-------
		bool
		
		"""


class Mobile:
	"""		
	"""
	Backpack: "Item"
	Body: "UInt16"
	CanRename: bool
	Color: "UInt16"
	Contains: "List[Item]"
	Direction: str
	Fame: int
	Female: bool
	Flying: bool
	Hits: int
	HitsMax: int
	Hue: "UInt16"
	InParty: bool
	IsGhost: bool
	IsHuman: bool
	ItemID: "UInt16"
	Karma: int
	KarmaTitle: str
	Mana: int
	ManaMax: int
	Map: int
	MobileID: int
	Mount: "Item"
	Name: str
	Notoriety: int
	Paralized: bool
	Poisoned: bool
	Position: "Point3D"
	Properties: "List[Property]"
	PropsUpdated: bool
	Quiver: "Item"
	Serial: int
	Stam: int
	StamMax: int
	TypeID: "UInt16"
	Visible: bool
	WarMode: bool
	YellowHits: bool
	def DistanceTo(self, other_mobile: "Mobile") -> int:
		"""
		
		Parameters
		----------
		other_mobile: Mobile
		
		Returns
		-------
		int
		
		"""

	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def GetItemOnLayer(self, layer: str) -> "Item":
		"""
		
		Parameters
		----------
		layer: str
		
		Returns
		-------
		Item
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	def UpdateKarma(self) -> bool:
		"""
		
		Returns
		-------
		bool
		
		"""


class Mobiles:
	"""		
	"""

	@staticmethod
	def ApplyFilter(filter: "Filter") -> "List[Mobile]":
		"""
		
		Parameters
		----------
		filter: Filter
		
		Returns
		-------
		List[Mobile]
		
		"""

	@staticmethod
	def ContextExist(mob: Union["Mobile", int], name: str, showContext: bool) -> int:
		"""
		
		Parameters
		----------
		mob: Mobile or int
		name: str
		showContext: bool
		
		Returns
		-------
		int
		
		"""

	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def FindBySerial(serial: int) -> "Mobile":
		"""
		
		Parameters
		----------
		serial: int
		
		Returns
		-------
		Mobile
		
		"""

	@staticmethod
	def FindMobile(graphics: Union["List[Int32]", int], notoriety: "List[Byte]", rangemax: int, selector: str, highlight: bool) -> "Mobile":
		"""
		
		Parameters
		----------
		graphics: List[Int32] or int
		notoriety: List[Byte]
		rangemax: int
		selector: str
		highlight: bool
		
		Returns
		-------
		Mobile
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def GetPropStringByIndex(serial: Union[int, "Mobile"], index: int) -> str:
		"""
		
		Parameters
		----------
		serial: int or Mobile
		index: int
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def GetPropStringList(mob: Union["Mobile", int]) -> "List[String]":
		"""
		
		Parameters
		----------
		mob: Mobile or int
		
		Returns
		-------
		List[String]
		
		"""

	@staticmethod
	def GetPropValue(serial: Union[int, "Mobile"], name: str) -> float:
		"""
		
		Parameters
		----------
		serial: int or Mobile
		name: str
		
		Returns
		-------
		float
		
		"""

	@staticmethod
	def GetTrackingInfo() -> "TrackingInfo":
		"""
		
		Returns
		-------
		TrackingInfo
		
		"""

	@staticmethod
	def Message(serial: Union[int, "Mobile"], hue: int, message: str, wait: bool):
		"""
		
		Parameters
		----------
		serial: int or Mobile
		hue: int
		message: str
		wait: bool
		
		"""

	@staticmethod
	def Select(mobiles: "List[Mobile]", selector: str) -> "Mobile":
		"""
		
		Parameters
		----------
		mobiles: List[Mobile]
		selector: str
		
		Returns
		-------
		Mobile
		
		"""

	@staticmethod
	def SingleClick(serial: Union[int, "Mobile"]):
		"""
		
		Parameters
		----------
		serial: int or Mobile
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def UseMobile(mobileserial: Union[int, "Mobile"]):
		"""
		
		Parameters
		----------
		mobileserial: int or Mobile
		
		"""

	@staticmethod
	def WaitForProps(m: Union["Mobile", int], delay: int) -> bool:
		"""
		
		Parameters
		----------
		m: Mobile or int
		delay: int
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def WaitForStats(mobileserial: Union[int, "Mobile"], delay: int) -> bool:
		"""
		
		Parameters
		----------
		mobileserial: int or Mobile
		delay: int
		
		Returns
		-------
		bool
		
		"""


class Player:
	"""		
	"""
	AR: int
	Backpack: "Item"
	Bank: "Item"
	Body: int
	Buffs: "List[String]"
	BuffsInfo: "List[BuffInfo]"
	ColdResistance: int
	Connected: bool
	Corpses: "HashSet[Item]"
	DamageChanceIncrease: int
	DefenseChanceIncrease: int
	Dex: int
	DexterityIncrease: int
	Direction: str
	EnergyResistance: int
	EnhancePotions: int
	Fame: int
	FasterCasting: int
	FasterCastRecovery: int
	Female: bool
	FireResistance: int
	Followers: int
	FollowersMax: int
	Gold: int
	HasPrimarySpecial: bool
	HasSecondarySpecial: bool
	HasSpecial: bool
	HitPointsIncrease: int
	HitPointsRegeneration: int
	Hits: int
	HitsMax: int
	InParty: bool
	Int: int
	IntelligenceIncrease: int
	IsGhost: bool
	Karma: int
	KarmaTitle: str
	LowerManaCost: int
	LowerReagentCost: int
	Luck: int
	Mana: int
	ManaIncrease: int
	ManaMax: int
	ManaRegeneration: int
	Map: int
	MaximumHitPointsIncrease: int
	MaximumStaminaIncrease: int
	MaxWeight: int
	MobileID: int
	Mount: "Item"
	Name: str
	Notoriety: int
	Paralized: bool
	Pets: "List[Mobile]"
	Poisoned: bool
	PoisonResistance: int
	Position: "Point3D"
	PrimarySpecial: "UInt32"
	Quiver: "Item"
	ReflectPhysicalDamage: int
	SecondarySpecial: "UInt32"
	Serial: int
	SpellDamageIncrease: int
	Stam: int
	StaminaIncrease: int
	StaminaRegeneration: int
	StamMax: int
	StatCap: int
	StaticMount: int
	Str: int
	StrengthIncrease: int
	SwingSpeedIncrease: int
	Visible: bool
	WarMode: bool
	Weight: int
	YellowHits: bool
	@staticmethod
	def Area() -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def Attack(mobile: Union["Mobile", int]):
		"""
		
		Parameters
		----------
		mobile: Mobile or int
		
		"""

	@staticmethod
	def AttackLast():
		"""
		
		"""

	@staticmethod
	def AttackType(graphic: Union[int, "List[Int32]"], rangemax: int, selector: str, color: "List[Int32]", notoriety: "List[Byte]") -> bool:
		"""
		
		Parameters
		----------
		graphic: int or List[Int32]
		rangemax: int
		selector: str
		color: List[Int32]
		notoriety: List[Byte]
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def BuffsExist(buffname: str, okayToGuess: bool) -> bool:
		"""
		
		Parameters
		----------
		buffname: str
		okayToGuess: bool
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def BuffTime(buffname: str) -> int:
		"""
		
		Parameters
		----------
		buffname: str
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def ChatAlliance(msg: Union[int, str]):
		"""
		
		Parameters
		----------
		msg: int or str
		
		"""

	@staticmethod
	def ChatChannel(msg: Union[int, str]):
		"""
		
		Parameters
		----------
		msg: int or str
		
		"""

	@staticmethod
	def ChatEmote(color: int, msg: Union[str, int]):
		"""
		
		Parameters
		----------
		color: int
		msg: str or int
		
		"""

	@staticmethod
	def ChatGuild(msg: Union[str, int]):
		"""
		
		Parameters
		----------
		msg: str or int
		
		"""

	@staticmethod
	def ChatParty(msg: str, recepient_serial: int):
		"""
		
		Parameters
		----------
		msg: str
		recepient_serial: int
		
		"""

	@staticmethod
	def ChatSay(color: Union[int, str], msg: Union[str, int, None] = None):
		"""
		
		Parameters
		----------
		color: int or str
		msg: str or int or None
		
		"""

	@staticmethod
	def ChatWhisper(color: int, msg: Union[int, str]):
		"""
		
		Parameters
		----------
		color: int
		msg: int or str
		
		"""

	@staticmethod
	def ChatYell(color: int, msg: Union[int, str]):
		"""
		
		Parameters
		----------
		color: int
		msg: int or str
		
		"""

	@staticmethod
	def CheckLayer(layer: str) -> bool:
		"""
		
		Parameters
		----------
		layer: str
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def ClearCorpseList():
		"""
		
		"""

	@staticmethod
	def DistanceTo(target: Union["Entity", int]) -> int:
		"""
		
		Parameters
		----------
		target: Entity or int
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def EmoteAction(action: str):
		"""
		
		Parameters
		----------
		action: str
		
		"""

	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def EquipItem(serial: Union[int, "Item"]):
		"""
		
		Parameters
		----------
		serial: int or Item
		
		"""

	@staticmethod
	def EquipLastWeapon():
		"""
		
		"""

	@staticmethod
	def EquipUO3D(_serials: Union["PythonList", "List[Int32]"]):
		"""
		
		Parameters
		----------
		_serials: PythonList or List[Int32]
		
		"""

	@staticmethod
	def Fly(status: bool):
		"""
		
		Parameters
		----------
		status: bool
		
		"""

	@staticmethod
	def GetBuffInfo(buffName: str, okayToGuess: bool) -> "BuffInfo":
		"""
		
		Parameters
		----------
		buffName: str
		okayToGuess: bool
		
		Returns
		-------
		BuffInfo
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def GetItemOnLayer(layer: str) -> "Item":
		"""
		
		Parameters
		----------
		layer: str
		
		Returns
		-------
		Item
		
		"""

	@staticmethod
	def GetPropStringByIndex(index: int) -> str:
		"""
		
		Parameters
		----------
		index: int
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def GetPropStringList() -> "List[String]":
		"""
		
		Returns
		-------
		List[String]
		
		"""

	@staticmethod
	def GetPropValue(name: str) -> int:
		"""
		
		Parameters
		----------
		name: str
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def GetRealSkillValue(skillname: str) -> float:
		"""
		
		Parameters
		----------
		skillname: str
		
		Returns
		-------
		float
		
		"""

	@staticmethod
	def GetSkillCap(skillname: str) -> float:
		"""
		
		Parameters
		----------
		skillname: str
		
		Returns
		-------
		float
		
		"""

	@staticmethod
	def GetSkillStatus(skillname: str) -> int:
		"""
		
		Parameters
		----------
		skillname: str
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def GetSkillValue(skillname: str) -> float:
		"""
		
		Parameters
		----------
		skillname: str
		
		Returns
		-------
		float
		
		"""

	@staticmethod
	def GetStatStatus(statname: str) -> int:
		"""
		
		Parameters
		----------
		statname: str
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def GuildButton():
		"""
		
		"""

	@staticmethod
	def HeadMessage(color: int, msg: Union[int, str]):
		"""
		
		Parameters
		----------
		color: int
		msg: int or str
		
		"""

	@staticmethod
	def InRange(serial: Union[int, "Entity"], range: int) -> bool:
		"""
		
		Parameters
		----------
		serial: int or Entity
		range: int
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def InRangeItem(item: Union[int, "Item"], range: int) -> bool:
		"""
		
		Parameters
		----------
		item: int or Item
		range: int
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def InRangeMobile(mobile: Union["Mobile", int], range: int) -> bool:
		"""
		
		Parameters
		----------
		mobile: Mobile or int
		range: int
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def InvokeVirtue(virtue: Union[str, int]):
		"""
		
		Parameters
		----------
		virtue: str or int
		
		"""

	@staticmethod
	def KickMember(serial: int):
		"""
		
		Parameters
		----------
		serial: int
		
		"""

	@staticmethod
	def LeaveParty(force: bool):
		"""
		
		Parameters
		----------
		force: bool
		
		"""

	@staticmethod
	def MapSay(msg: Union[str, int]):
		"""
		
		Parameters
		----------
		msg: str or int
		
		"""

	@staticmethod
	def OpenPaperDoll():
		"""
		
		"""

	@staticmethod
	def PartyAccept(from_serial: int, force: bool) -> bool:
		"""
		
		Parameters
		----------
		from_serial: int
		force: bool
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def PartyCanLoot(CanLoot: bool):
		"""
		
		Parameters
		----------
		CanLoot: bool
		
		"""

	@staticmethod
	def PartyInvite():
		"""
		
		"""

	@staticmethod
	def PathFindTo(x: Union[int, "Point3D"], y: Union[int, None] = None, z: Union[int, None] = None):
		"""
		
		Parameters
		----------
		x: int or Point3D
		y: int or None
		z: int or None
		
		"""

	@staticmethod
	def QuestButton():
		"""
		
		"""

	@staticmethod
	def Run(direction: str) -> bool:
		"""
		
		Parameters
		----------
		direction: str
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def SetSkillStatus(skillname: str, status: int):
		"""
		
		Parameters
		----------
		skillname: str
		status: int
		
		"""

	@staticmethod
	def SetStaticMount(serial: int):
		"""
		
		Parameters
		----------
		serial: int
		
		"""

	@staticmethod
	def SetStatStatus(statname: str, status: int):
		"""
		
		Parameters
		----------
		statname: str
		status: int
		
		"""

	@staticmethod
	def SetWarMode(warflag: bool):
		"""
		
		Parameters
		----------
		warflag: bool
		
		"""

	@staticmethod
	def SpellIsEnabled(spellname: str) -> bool:
		"""
		
		Parameters
		----------
		spellname: str
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def SumAttribute(attributename: str) -> float:
		"""
		
		Parameters
		----------
		attributename: str
		
		Returns
		-------
		float
		
		"""

	@staticmethod
	def ToggleAlwaysRun():
		"""
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def TrackingArrow(x: "UInt16", y: "UInt16", display: bool, target: "UInt32"):
		"""
		
		Parameters
		----------
		x: UInt16
		y: UInt16
		display: bool
		target: UInt32
		
		"""

	@staticmethod
	def UnEquipItemByLayer(layer: str, wait: bool):
		"""
		
		Parameters
		----------
		layer: str
		wait: bool
		
		"""

	@staticmethod
	def UnEquipUO3D(_layers: Union["PythonList", "List[String]"]):
		"""
		
		Parameters
		----------
		_layers: PythonList or List[String]
		
		"""

	def UpdateKarma(self) -> bool:
		"""
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def UseSkill(skillname: str, target: Union["Mobile", "Item", int, bool, None] = None, wait: Union[bool, None] = None):
		"""
		
		Parameters
		----------
		skillname: str
		target: Mobile or Item or int or bool or None
		wait: bool or None
		
		"""

	@staticmethod
	def UseSkillOnly(skillname: str, wait: bool):
		"""
		
		Parameters
		----------
		skillname: str
		wait: bool
		
		"""

	@staticmethod
	def Walk(direction: str) -> bool:
		"""
		
		Parameters
		----------
		direction: str
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def WeaponClearSA():
		"""
		
		"""

	@staticmethod
	def WeaponDisarmSA():
		"""
		
		"""

	@staticmethod
	def WeaponPrimarySA():
		"""
		
		"""

	@staticmethod
	def WeaponSecondarySA():
		"""
		
		"""

	@staticmethod
	def WeaponStunSA():
		"""
		
		"""

	@staticmethod
	def Zone() -> str:
		"""
		
		Returns
		-------
		str
		
		"""


class Point2D:
	"""		
	"""
	MinusOne: "Point2D"
	X: int
	Y: int
	Zero: "Point2D"
	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""


class Point3D:
	"""		
	"""
	X: int
	Y: int
	Z: int
	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""


class Property:
	"""		
	"""
	Args: str
	Number: int
	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""


class Spells:
	"""		
	"""

	@staticmethod
	def Cast(SpellName: str, mobile: Union["Mobile", "UInt32", int], wait: Union[bool, None] = None, waitAfter: Union[int, None] = None):
		"""
		
		Parameters
		----------
		SpellName: str
		mobile: Mobile or UInt32 or int
		wait: bool or None
		waitAfter: int or None
		
		"""

	@staticmethod
	def CastBushido(SpellName: str, wait: bool, waitAfter: int):
		"""
		
		Parameters
		----------
		SpellName: str
		wait: bool
		waitAfter: int
		
		"""

	@staticmethod
	def CastChivalry(SpellName: str, target: Union["UInt32", "Mobile", int], wait: Union[bool, None] = None, waitAfter: Union[int, None] = None):
		"""
		
		Parameters
		----------
		SpellName: str
		target: UInt32 or Mobile or int
		wait: bool or None
		waitAfter: int or None
		
		"""

	@staticmethod
	def CastCleric(SpellName: str, target: Union["UInt32", "Mobile", int], wait: Union[bool, None] = None, waitAfter: Union[int, None] = None):
		"""
		
		Parameters
		----------
		SpellName: str
		target: UInt32 or Mobile or int
		wait: bool or None
		waitAfter: int or None
		
		"""

	@staticmethod
	def CastDruid(SpellName: str, target: Union["UInt32", "Mobile", int], wait: Union[bool, None] = None, waitAfter: Union[int, None] = None):
		"""
		
		Parameters
		----------
		SpellName: str
		target: UInt32 or Mobile or int
		wait: bool or None
		waitAfter: int or None
		
		"""

	@staticmethod
	def CastLastSpell(target: Union["UInt32", "Mobile", bool], wait: Union[bool, None] = None):
		"""
		
		Parameters
		----------
		target: UInt32 or Mobile or bool
		wait: bool or None
		
		"""

	@staticmethod
	def CastLastSpellLastTarget():
		"""
		
		"""

	@staticmethod
	def CastMagery(SpellName: str, target: Union["UInt32", "Mobile", int], wait: Union[bool, None] = None, waitAfter: Union[int, None] = None):
		"""
		
		Parameters
		----------
		SpellName: str
		target: UInt32 or Mobile or int
		wait: bool or None
		waitAfter: int or None
		
		"""

	@staticmethod
	def CastMastery(SpellName: str, target: Union["UInt32", "Mobile", int], wait: Union[bool, None] = None, waitAfter: Union[int, None] = None):
		"""
		
		Parameters
		----------
		SpellName: str
		target: UInt32 or Mobile or int
		wait: bool or None
		waitAfter: int or None
		
		"""

	@staticmethod
	def CastMysticism(SpellName: str, target: Union["UInt32", "Mobile", int], wait: Union[bool, None] = None, waitAfter: Union[int, None] = None):
		"""
		
		Parameters
		----------
		SpellName: str
		target: UInt32 or Mobile or int
		wait: bool or None
		waitAfter: int or None
		
		"""

	@staticmethod
	def CastNecro(SpellName: str, target: Union["UInt32", "Mobile", int], wait: Union[bool, None] = None, waitAfter: Union[int, None] = None):
		"""
		
		Parameters
		----------
		SpellName: str
		target: UInt32 or Mobile or int
		wait: bool or None
		waitAfter: int or None
		
		"""

	@staticmethod
	def CastNinjitsu(SpellName: str, mobile: Union["Mobile", "UInt32", int], wait: Union[bool, None] = None, waitAfter: Union[int, None] = None):
		"""
		
		Parameters
		----------
		SpellName: str
		mobile: Mobile or UInt32 or int
		wait: bool or None
		waitAfter: int or None
		
		"""

	@staticmethod
	def CastSpellweaving(SpellName: str, target: Union["UInt32", "Mobile", int], wait: Union[bool, None] = None, waitAfter: Union[int, None] = None):
		"""
		
		Parameters
		----------
		SpellName: str
		target: UInt32 or Mobile or int
		wait: bool or None
		waitAfter: int or None
		
		"""

	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def Interrupt():
		"""
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""


class Target:
	"""		
	"""

	@staticmethod
	def Cancel():
		"""
		
		"""

	@staticmethod
	def ClearLast():
		"""
		
		"""

	@staticmethod
	def ClearLastandQueue():
		"""
		
		"""

	@staticmethod
	def ClearLastAttack():
		"""
		
		"""

	@staticmethod
	def ClearQueue():
		"""
		
		"""

	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def GetLast() -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def GetLastAttack() -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def HasTarget(targetFlag: str) -> bool:
		"""
		
		Parameters
		----------
		targetFlag: str
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def Last():
		"""
		
		"""

	@staticmethod
	def LastQueued():
		"""
		
		"""

	@staticmethod
	def LastUsedObject() -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def PromptGroundTarget(self, message: str, color: int) -> "Point3D":
		"""
		
		Parameters
		----------
		message: str
		color: int
		
		Returns
		-------
		Point3D
		
		"""

	def PromptTarget(self, message: str, color: int) -> int:
		"""
		
		Parameters
		----------
		message: str
		color: int
		
		Returns
		-------
		int
		
		"""

	@staticmethod
	def Self():
		"""
		
		"""

	@staticmethod
	def SelfQueued():
		"""
		
		"""

	@staticmethod
	def SetLast(serial: Union[int, "Mobile"], wait: Union[bool, None] = None):
		"""
		
		Parameters
		----------
		serial: int or Mobile
		wait: bool or None
		
		"""

	@staticmethod
	def TargetExecute(x: int, y: Union[int, None] = None, z: Union[int, None] = None, StaticID: Union[int, None] = None):
		"""
		
		Parameters
		----------
		x: int
		y: int or None
		z: int or None
		StaticID: int or None
		
		"""

	@staticmethod
	def TargetExecuteRelative(serial: Union[int, "Mobile"], offset: int):
		"""
		
		Parameters
		----------
		serial: int or Mobile
		offset: int
		
		"""

	@staticmethod
	def TargetResource(item_serial: Union[int, "Item"], resource_name: Union[str, int]):
		"""
		
		Parameters
		----------
		item_serial: int or Item
		resource_name: str or int
		
		"""

	@staticmethod
	def TargetType(graphic: int, color: int, range: int, selector: str, notoriety: "List[Byte]") -> bool:
		"""
		
		Parameters
		----------
		graphic: int
		color: int
		range: int
		selector: str
		notoriety: List[Byte]
		
		Returns
		-------
		bool
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""

	@staticmethod
	def WaitForTarget(delay: int, noshow: bool) -> bool:
		"""
		
		Parameters
		----------
		delay: int
		noshow: bool
		
		Returns
		-------
		bool
		
		"""

	@staticmethod
	def WaitForTargetOrFizzle(delay: int, noshow: bool) -> bool:
		"""
		
		Parameters
		----------
		delay: int
		noshow: bool
		
		Returns
		-------
		bool
		
		"""


class TrackingInfo:
	"""		
	"""
	lastUpdate: "DateTime"
	serial: "UInt32"
	x: "UInt16"
	y: "UInt16"
	def Equals(self, obj: object) -> bool:
		"""
		
		Parameters
		----------
		obj: object
		
		Returns
		-------
		bool
		
		"""

	def GetHashCode(self) -> int:
		"""
		
		Returns
		-------
		int
		
		"""

	def ToString(self) -> str:
		"""
		
		Returns
		-------
		str
		
		"""

